//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
//---------------------------------------------------------------------------
#pragma link "WSockets"
#pragma link "mdTray"
#pragma link "mdMsgCmp"
#pragma link "TJabber"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
    Buffer="";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TCP1Connect(TObject *Sender, int Socket)
{
	SetCaption("Connected");
    Jabber1->Connect();
    Jabber1->FetchRoster();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::TCP1Data(TObject *Sender, int Socket)
{
	Jabber1->LoadData(TCP1->Read());
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Jabber1ServerInfo(TObject *Sender, AnsiString Version,
	AnsiString Protocol)
{
	SText->Caption=Version;
    PText->Caption=Protocol;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Jabber1NewNote(TObject *Sender, AnsiString From,
	AnsiString FromNickName, AnsiString Ext, AnsiString Thread,
	AnsiString Priority, AnsiString Subject, AnsiString Message)
{
//	MessageBox(NULL,"New Note came in","New Note",MB_OK);
	JabberNote(From,FromNickName,Ext,Thread,Priority,Subject,Message);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Jabber1SendData(TObject *Sender, AnsiString Data)
{
//	MessageBox(NULL,Data.c_str(),"Send this:",MB_OK);
	TCP1->Write(Data);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Jabber1RosterUpdate(TObject *Sender)
{
//	MessageBox(NULL,"Roster Update","Roster Update",MB_OK);

	List->Clear();

    TStringList *L,*G;

    G=new TStringList();
    L=new TStringList();

    Jabber1->RosterGroups(G);

    for(int i=0; i<G->Count; i++){
    	L->Clear();
    	Jabber1->RosterList(G->Strings[i],L);
		for(int j=0; j<L->Count; j++)
	        List->Items->Add(AnsiString(L->Strings[j]) + " - [" + AnsiString(G->Strings[i]) + "]");
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	Jabber1->ClientPriority=Priority->Text.ToInt();
	Jabber1->ClientStatus=Status->Text;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{
	Jabber1->UserName=UName->Text;
	Jabber1->UserPassword=Password->Text;
	Jabber1->UserNickName=NName->Text;

	Jabber1->ClientPriority=Priority->Text.ToInt();
	Jabber1->ClientStatus=Status->Text;

	TCP1->Host=Server->Text;
	TCP1->Open();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DButtonClick(TObject *Sender)
{
	Jabber1->Disconnect();
    TCP1->Close();
    List->Clear();
    SetCaption("Not Connected");
    SText->Caption="<unknown>";
    PText->Caption=SText->Caption;	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
	DButton->Click();	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
	Jabber1->RosterAddUser(RGroup->Text,RUsername->Text);	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	Jabber1->FetchRoster();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
	SetCaption("Not Connected");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SetCaption(AnsiString Caption)
{
	Application->Title="Jabber - " + Caption;
    Form1->Caption="Jabber - " + Caption;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::JabberNote(AnsiString From, AnsiString Nickname, AnsiString Ext, AnsiString Thread, AnsiString Priority, AnsiString Subject, AnsiString Message)
{
	TMForm* Form;
	Form=new TMForm(this);

    Form->Label1->Caption="From:";
    Form->From->Caption=From;
    Form->Nick->Caption=Nickname;
    Form->Ext->Caption=Ext;
    Form->Priority->Caption=Priority;
    Form->Thread->Caption=Thread;
    Form->Subject->Caption=Subject;
    Form->Message->Lines->Add(Message);
    Form->Caption="Jabber Note: " + Subject;
    Form->Show();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{
	MessageBox(Form1->Handle,"Not working yet..","Sorry",MB_OK);
//	Jabber1->SendJabberNote("bob", "Bob", "", "Thread", "5", "Subject", "Message goes here");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
	TNewNote *Form;
    Form=new TNewNote(this);
	Form->Show();
}
//---------------------------------------------------------------------------
